/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package csbs2.ui;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JLabel;

/**
 *
 * @author Luke
 */
public class StatusLabel extends JLabel {

    float pi = 0;
    float pe = 0;
    float lpi = 0;
    float lpe = 0;
    int cri = 0;
    int sri = 0;
    public int off = 0;
    boolean first = true;
    SmoothInteger serverspeed = new SmoothInteger(0, 8);
    SmoothInteger clientspeed = new SmoothInteger(0, 8);
    BufferedImage buff = new BufferedImage(2000, 200, BufferedImage.TYPE_INT_ARGB);
    BufferedImage back = new BufferedImage(2000, 200, BufferedImage.TYPE_INT_ARGB);
    Graphics2D g;
    public static boolean s = false;
    public static boolean c = false;

    @Override
    public void paint(Graphics raw) {
        if (first) {
            first = false;
            new Thread(new Runnable() {

                public void run() {
                    while (true) {
                        try {
                            Thread.sleep(1000 / 32);
                            java.awt.EventQueue.invokeLater(new Runnable() {

                                public void run() {
                                    repaint();
                                }
                            });
                        } catch (InterruptedException ex) {
                            return;
                        }
                    }
                }
            }).start();

        }
        moveleft();
        g = buff.createGraphics();
        off++;
        serverspeed.setTo((int) Filters.bps_s);
        clientspeed.setTo((int) Filters.bps_c);
        s = serverspeed.done();
        c = clientspeed.done();

        //if (true) {
        if (off >= 6) {
            g.setColor(new Color(0, 65, 0));
            g.drawLine(0, 0, 0, this.getHeight());
            off = 0;
            //System.out.println("lol");
        } else {
            g.setColor(new Color(0, 0, 0));
            g.drawLine(0, 0, 0, this.getHeight());
            g.setColor(new Color(0, 65, 0));
            for (int i = 0; i < this.getHeight(); i += 6) {
                g.drawLine(0, i, 0, i);
            }
        }
        //
        try {
            pi = (float) this.getHeight() * (((float) (serverspeed.process())) / Filters.bps_max);
            pe = (float) this.getHeight() * (((float) (clientspeed.process())) / Filters.bpc_max);
//            pi-=(float)this.getHeight();
//            pe-=(float)this.getHeight();
        } catch (Exception ee) {
        }
        pi = (float) (this.getHeight()) - pi;
        pe = (float) (this.getHeight()) - pe;

        g.setColor(Color.RED);
        g.drawLine(0, (int) Math.round(pi), 0, (int) Math.round(pi) + 1);
        //g.setColor(new Color(100, 2, 2, 130));
        g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.5f));
        g.drawLine(0, this.getHeight(), 0, (int) Math.round(pi) - 1);
        g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.8f));
        if (Filters.sr) {
            Filters.sr = false;
            sr = true;
            //g.setColor(Color.RED);
            g.fillOval(4, 2, 6, 6);
        }
        g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1.0f));

        g.setColor(Color.GREEN);
        g.drawLine(0, (int) Math.round(pe) + 2, 0, (int) Math.round(pe) + 3);
        //g.setColor(new Color(2, 100, 2, 130));
        g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.3f));

        g.drawLine(0, this.getHeight(), 0, (int) Math.round(pe));
        g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.6f));
        if (Filters.cr) {
            Filters.cr = false;
            cr = true;
            //g.setColor(Color.GREEN);
            g.fillOval(4, 7, 6, 6);
        }
        g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1.0f));

        raw.drawImage(buff, 0, 0, null);
        super.paint(raw);
        raw.setColor(Color.GREEN);
        if (cr) {
            cri++;
            if (cri > 5) {
                cri = 0;
                cr = false;
            }
            //g.setColor(Color.GREEN);
            raw.fillOval(4, 7, 6, 6);
        }
        raw.setColor(Color.RED);
        if (sr) {
            sri++;
            if (sri > 5) {
                sri = 0;
                sr = false;
            }
            //g.setColor(Color.RED);
            raw.fillOval(4, 2, 6, 6);
        }
        raw.setColor(Color.LIGHT_GRAY);
        raw.drawOval(4, 2, 6, 6);
        raw.drawOval(4, 7, 6, 6);
        raw.drawLine(10, 8, 10, 8);
        raw.drawLine(10, 7, 10, 7);
        raw.drawLine(4, 8, 4, 8);
        raw.drawLine(4, 7, 4, 7);

    }
    boolean sr = false;
    boolean cr = false;
    BufferedImage buff2 = new BufferedImage(2000, 200, BufferedImage.TYPE_INT_ARGB);

    private void moveleft() {
        buff2 = new BufferedImage(1000, 200, BufferedImage.TYPE_INT_ARGB);
        buff2.createGraphics().drawImage(buff, 1, 0, null);
        buff = buff2;
    }
}
